#include <errno.h>
#include <sys/acl.h>

ssize_t		acl_copy_ext (void *buf_p, acl_t acl_d, ssize_t size)
{
	acl_entry_t	acle1;
	acl_entry_t	acle2;

	CHECK_ACL_VALID (acl_d, -1);
	if (size <= 0) {
		errno = EINVAL;
		return -1;
	}
	if (size < acl_size (acl_d)) {
		errno = ERANGE;
		return -1;
	}
	memcpy (buf_p, (void *)acl_d, sizeof (struct acl));
	acle1 = acl_d->acl_faclep;
	acle2 = (acl_entry_t)((char *)buf_p + sizeof (struct acl));
	while (acle1) {
		memcpy ((void *)acle2, (void *)acle1, sizeof (struct acl_entry));
		acle2->acle_aclp = NULL;
		acle1 = acle1->acle_next;
		acle2++;
	}
	return 0;
}
