#include <errno.h>
#include <sys/acl.h>

acl_t		acl_copy_int (const void *buf_p)
{
	acl_t		acl;
	acl_entry_t	acle1;
	acl_entry_t	acle2;
	acl_entry_t	aclep;
	int		i;
	int		acle_count;

	CHECK_ACL_VALID (((acl_t)buf_p), NULL);
	acl = acl_init (sizeof (struct acl));
	if (!acl)
		return NULL;
	acle_count = ((acl_t)buf_p)->acl_acle_count;
	acle1 = (acl_entry_t)((char *)buf_p + sizeof (struct acl));
	aclep = NULL;
	for (i = 0; i < acle_count; i++) {
		acle2 = (acl_entry_t)malloc (sizeof (struct acl_entry));
		if (!acle2) {
			acl_free (acl);
			errno = ENOMEM;
			return NULL;
		}
		memcpy ((void *)acle2, (void *)acle1, sizeof (struct acl_entry));
		acle2->acle_valid = VALID_ACL_ENTRY;
		acle2->acle_aclp = acl;
		acle2->acle_prev = aclep;
		acle2->acle_next = NULL;
		if (aclep == NULL)
			acl->acl_faclep = acle2;
		else
			aclep->acle_next = acle2;
		acl->acl_laclep = acle2;
		aclep = acle2;
		acl->acl_acle_count++;
		acl->acl_used_acle++;
	}
	return acl;
}
