#include <errno.h>
#include <string.h>
#include <sys/acl.h>

acl_entry_t	acl_create_entry (acl_t *acl_p)
{
	acl_t		acl;
	acl_entry_t	acle;

	if (!acl_p) {
		errno = EINVAL;
		return NULL;
	}
	acl = *acl_p;
	CHECK_ACL_VALID (acl, NULL);
	if (acl->acl_free) {
		acle = acl->acl_free;
		acl->acl_free = acl->acl_free->acle_next;
	} else {
		acle = (acl_entry_t)malloc (sizeof (struct acl_entry));
		if (!acle) {
			errno = ENOMEM;
			return NULL;
		}
		memset ((void *)acle, 0, sizeof (struct acl_entry));
		acl->acl_acle_count++;
	}
	acle->acle_valid = VALID_ACL_ENTRY;
	acle->acle_aclp = acl;
	acle->acle_prev = acl->acl_laclep;
	acle->acle_next = NULL;
	if (acl->acl_laclep)
		acl->acl_laclep->acle_next = acle;
	if (!acl->acl_faclep)
		acl->acl_faclep = acle;
	acl->acl_laclep = acle;
	acl->acl_used_acle++;
	return acle;
}
