#include <errno.h>
#include <sys/acl.h>

acl_t		acl_dup (const acl_t acl_d)
{
	acl_t		acl;
	acl_entry_t	acle1;
	acl_entry_t	acle2;
	acl_entry_t	aclep;

	CHECK_ACL_VALID (acl_d, NULL);
	acl = acl_init (sizeof (struct acl));
	if (!acl)
		return NULL;
	aclep = NULL;
	for (acle1 = acl_d->acl_faclep; acle1; acle1 = acle1->acle_next) {
		acle2 = (acl_entry_t)malloc (sizeof (struct acl_entry));
		if (!acle2) {
			acl_free (acl);
			errno = ENOMEM;
			return NULL;
		}
		memcpy ((void *)acle2, (void *)acle1, sizeof (struct acl_entry));
		acle2->acle_aclp = acl;
		acle2->acle_prev = aclep;
		acle2->acle_next = NULL;
		if (aclep == NULL)
			acl->acl_faclep = acle2;
		else
			aclep->acle_next = acle2;
		acl->acl_laclep = acle2;
		aclep = acle2;
		acl->acl_acle_count++;
		acl->acl_used_acle++;
	}
	return acl;
}
