#include <errno.h>
#include <sys/acl.h>

void		*acl_get_qualifier (const acl_entry_t entry_d)
{
	void		*p;

	CHECK_ACLE_VALID (entry_d, NULL);
	switch (entry_d->acle_tag_type) {
		case ACL_USER:
			p = (void *)malloc (sizeof (uid_t));
			if (p)
				*((uid_t *)p) = entry_d->acle_tag;
			break;
		case ACL_GROUP:
			p = (void *)malloc (sizeof (gid_t));
			if (p)
				*((gid_t *)p) = entry_d->acle_tag;
			break;
		default:
			p = NULL;
			errno = EINVAL;
			break;
	}
	return p;
}
