#include <errno.h>
#include <sys/acl.h>

int		acl_set_qualifier (acl_entry_t entry_d,
				   const void *tag_qualifier_d)
{
	CHECK_ACLE_VALID (entry_d, -1);
	switch (entry_d->acle_tag_type) {
		case ACL_USER:
			entry_d->acle_tag = *((uid_t *)tag_qualifier_d);
			break;
		case ACL_GROUP:
			entry_d->acle_tag = *((gid_t *)tag_qualifier_d);
			break;
		default:
			errno = EINVAL;
			return -1;
	}
	return 0;
}
