#include <errno.h>
#include <sys/acl.h>

int		acl_valid (acl_t acl_d, acl_entry_t *entry_p)
{
	int		acl_user_obj = 0;
	int		acl_group_obj = 0;
	int		acl_other_obj = 0;
	acl_entry_t	acle1;
	acl_entry_t	acle2;
	acl_entry_t	dummy_acle;

	CHECK_ACL_VALID (acl_d, -1);
	if (!entry_p)
		entry_p = &dummy_acle;
	*entry_p = NULL;
	for (acle1 = acl_d->acl_faclep; acle1; acle1 = acle1->acle_next)
		switch (acle1->acle_tag_type) {
			case ACL_USER_OBJ:
				if (acl_user_obj) {
					errno = EINVAL;
					*entry_p = acle1;
					return -1;
				}
				acl_user_obj = 1;
				break;
			case ACL_GROUP_OBJ:
				if (acl_group_obj) {
					errno = EINVAL;
					*entry_p = acle1;
					return -1;
				}
				acl_group_obj = 1;
				break;
			case ACL_OTHER_OBJ:
				if (acl_other_obj) {
					errno = EINVAL;
					*entry_p = acle1;
					return -1;
				}
				acl_other_obj = 1;
				break;
			case ACL_USER:
			case ACL_GROUP:
				for (acle2 = acle1->acle_next;
				     acle2;
				     acle2 = acle2->acle_next)
					if (acle1->acle_tag_type == acle2->acle_tag_type
					    && acle1->acle_tag == acle2->acle_tag) {
						errno = EINVAL;
						*entry_p = acle2;
						return -1;
					}
				break;
			default:
				errno = EINVAL;
				*entry_p = acle1;
				return -1;
		}
	if (!(acl_user_obj && acl_group_obj && acl_other_obj)) {
		errno = EINVAL;
		return -1;
	}
	return 0;
}
